/*
 * main.c  -- entry point
 *
 * $Id: main.c,v 1.2 2004/05/24 11:16:22 hos Exp $
 *
 */


#include "main.h"
#include <string.h>


HINSTANCE instance = NULL;

migemo *(*migemo_open_p)(char *) = NULL;
void (*migemo_close_p)(migemo *) = NULL;
unsigned char *(*migemo_query_p)(migemo *, unsigned char *) = NULL;
void (*migemo_release_p)(migemo *, unsigned char *) = NULL;
int (*migemo_is_enable_p)(migemo *) = NULL;

static HMODULE migemo_module = NULL;

BOOL APIENTRY DllMain(HANDLE module, DWORD reason, LPVOID reserve)
{
    if(reason == DLL_PROCESS_ATTACH) {
        instance = (HINSTANCE)module;

        migemo_module = LoadLibrary(_T("migemo.dll"));
        if(migemo_module != NULL) {
            migemo_open_p =
                (migemo *(*)(char *))
                GetProcAddress(migemo_module, _T("migemo_open"));
            migemo_close_p =
                (void (*)(migemo *))
                GetProcAddress(migemo_module, _T("migemo_close"));
            migemo_query_p =
                (unsigned char *(*)(migemo *, unsigned char *))
                GetProcAddress(migemo_module, _T("migemo_query"));
            migemo_release_p =
                (void (*)(migemo *, unsigned char *))
                GetProcAddress(migemo_module, _T("migemo_release"));
            migemo_is_enable_p =
                (int (*)(migemo *))
                GetProcAddress(migemo_module, _T("migemo_is_enable"));
            if(migemo_open_p == NULL ||
               migemo_close_p == NULL ||
               migemo_query_p == NULL ||
               migemo_release_p == NULL ||
               migemo_is_enable_p == NULL) {
                migemo_open_p = NULL;
                migemo_close_p = NULL;
                migemo_query_p = NULL;
                migemo_release_p = NULL;
                migemo_is_enable_p = NULL;

                FreeLibrary(migemo_module);
                migemo_module = NULL;
            }
        }
    } else if(reason == DLL_PROCESS_DETACH) {
        if(migemo_module != NULL) {
            FreeLibrary(migemo_module);
            migemo_module = NULL;
        }
    }

    return TRUE;
}


void error_message(char *str, int code)
{
    TCHAR buf[256];

    wsprintf(buf, _T("%s: 0x%x"), str, code);
    MessageBox(NULL, buf, _T("migemo-isearch"), MB_ICONERROR | MB_OK);
}
