/*
 * main.h  -- definitions
 *
 * $Id: main.h,v 1.5 2004/05/25 02:44:30 hos Exp $
 *
 */


#include <ctype.h>
#include <tchar.h>
#include <windows.h>
#include <objbase.h>
#include <migemo.h>
#include "automation.h"
#include "regexp.h"


#define MODE_NORMAL        0x00000001
#define MODE_REGEXP        0x00000002
#define MODE_MIGEMO        0x00000004

#define MODE_INCREMENTAL   0x00000100
#define MODE_NOINCREMENTAL 0x00000200

#define MODE_IGNORECASE    0x00010000
#define MODE_CASESESITIVE  0x00020000

typedef struct wnd_ctx {
    IDispatch *doc;

    BSTR word;

    int dir;

    BOOL failing;
    BOOL wrapped;

    unsigned int mode;

    HWND parent;
    HWND main;
    HWND stat;
    HWND edit;

    char *migemo_dict;
    migemo *mp;

    IRegExp *regexp;

    LPOLESTR *range_text;
    LPOLESTR *range_dup;
    LPOLESTR *doc_all_range;

    HRESULT (*selected_range)(struct wnd_ctx *, IDispatch **);
    HRESULT (*range_find_proc)(IDispatch *, struct wnd_ctx *, BSTR,
                               VARIANT_BOOL *);
    HRESULT (*range_move_point)(IDispatch *, IDispatch *, int, int);
    HRESULT (*range_select)(struct wnd_ctx *, IDispatch *);
    HRESULT (*range_action)(struct wnd_ctx *, IDispatch *);

    HRESULT (*get_doc)(IDispatch **);
} wnd_ctx_t;


void isearch(wnd_ctx_t *ctx);


extern HINSTANCE instance;

extern migemo *(*migemo_open_p)(char *);
extern void (*migemo_close_p)(migemo *);
extern unsigned char *(*migemo_query_p)(migemo *, unsigned char *);
extern void (*migemo_release_p)(migemo *, unsigned char *);
extern int (*migemo_is_enable_p)(migemo *);

void error_message(char *str, int code);


HRESULT get_office_doc(IDispatch **doc, LPOLESTR progid, LPOLESTR prop);


#define DECLARE_FUNCTION(_pre_,_name_,_dir_,_mode_)   \
void WINAPI mayu ## _pre_ ## _ ## _name_ (char *param)  \
{                                                                       \
    wnd_ctx_t ctx;                                                      \
                                                                        \
    memset(&ctx, 0, sizeof(ctx));                                       \
                                                                        \
    ctx.migemo_dict = param;                                            \
    ctx.dir = _dir_;                                                    \
    ctx.mode = _mode_;                                                  \
                                                                        \
    if(FAILED(_pre_ ## _init_context(&ctx))) return;                    \
                                                                        \
    isearch(&ctx);                                                      \
}

#define DECLARE_FUNCTIONS(prefix)                                       \
DECLARE_FUNCTION(prefix,isearch_fi,+1,                                  \
                 (MODE_INCREMENTAL | MODE_NORMAL | MODE_IGNORECASE))    \
DECLARE_FUNCTION(prefix,isearch_f,+1,                                   \
                 (MODE_INCREMENTAL | MODE_NORMAL | MODE_CASESESITIVE))  \
DECLARE_FUNCTION(prefix,isearch_fri,+1,                                 \
                 (MODE_INCREMENTAL | MODE_REGEXP | MODE_IGNORECASE))    \
DECLARE_FUNCTION(prefix,isearch_fr,+1,                                  \
                 (MODE_INCREMENTAL | MODE_REGEXP | MODE_CASESESITIVE))  \
DECLARE_FUNCTION(prefix,isearch_fmi,+1,                                 \
                 (MODE_INCREMENTAL | MODE_MIGEMO | MODE_IGNORECASE))    \
DECLARE_FUNCTION(prefix,isearch_fm,+1,                                  \
                 (MODE_INCREMENTAL | MODE_MIGEMO | MODE_CASESESITIVE))  \
                                                                        \
DECLARE_FUNCTION(prefix,isearch_bi,-1,                                  \
                 (MODE_INCREMENTAL | MODE_NORMAL | MODE_IGNORECASE))    \
DECLARE_FUNCTION(prefix,isearch_b,-1,                                   \
                 (MODE_INCREMENTAL | MODE_NORMAL | MODE_CASESESITIVE))  \
DECLARE_FUNCTION(prefix,isearch_bri,-1,                                 \
                 (MODE_INCREMENTAL | MODE_REGEXP | MODE_IGNORECASE))    \
DECLARE_FUNCTION(prefix,isearch_br,-1,                                  \
                 (MODE_INCREMENTAL | MODE_REGEXP | MODE_CASESESITIVE))  \
DECLARE_FUNCTION(prefix,isearch_bmi,-1,                                 \
                 (MODE_INCREMENTAL | MODE_MIGEMO | MODE_IGNORECASE))    \
DECLARE_FUNCTION(prefix,isearch_bm,-1,                                  \
                 (MODE_INCREMENTAL | MODE_MIGEMO | MODE_CASESESITIVE))
